<ng-container *ngIf="vm$() as vm">
  <div [ngClass]="['e-walidata-list-monitor-business-field']">
    <div [ngClass]="['table-wrapper', jds.tablePaging]">
      <table
        [ngClass]="[jds.table, jds.mb(0)]"
        role="table"
        aria-label="List Monitor Business Field"
        aria-describedby="Table List Monitor Business Field"
        stickyTable
      >
        <thead
          [ngClass]="[jds.bg(jdsBiColor.gray['100'])]"
          [style.verticalAlign]="'middle'"
        >
          <tr>
            <th
              [ngClass]="[jds.minW(60)]"
              [style.zIndex]="20"
              stickyColumn
            >
              No
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="20"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              stickyColumn
              scope="col"
              column="kode_bidang_urusan"
            >
              Kode Urusan
            </th>
            <th
              [ngClass]="[jds.minW(400)]"
              [style.zIndex]="20"
              stickyColumn
            >
              Bidang Urusan
            </th>
            <th
              [ngClass]="[jds.minW(200)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_diisi_persentase"
            >
              Monitor Keterisian
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_belum_ditugaskan"
            >
              Belum Ditugaskan
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_ditugaskan"
            >
              Ditugaskan
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_dikembalikan"
            >
              Dikembalikan
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_pengajuan_nonaktif"
            >
              Pengajuan Nonaktif
            </th>
            <th
              [ngClass]="[jds.minW(130)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="count_nonaktif"
            >
              Nonaktif
            </th>
            <th
              [ngClass]="[jds.minW(165)]"
              [style.zIndex]="10"
              [colorScheme]="'gray'"
              [isSortable]="true"
              [currentSort]="{
                sort: vm.filterSort,
                direction: vm.filterDirection
              }"
              (filterSort)="onSort($event, vm.filterDirection)"
              jdsBiTableHead
              scope="col"
              column="last_update"
            >
              Update Terakhir
            </th>
            <th
              [ngClass]="[jds.minW(350)]"
              [colorScheme]="'gray'"
              [isFilterable]="true"
              jdsBiTableHead
              scope="col"
              column="kode_skpd"
            >
              <span>OPD</span>
              <div
                [style.cursor]="'pointer'"
                (click)="onOpenFilterOrganization()"
                filter
                role="button"
              >
                <jds-bi-hosted-dropdown
                  [(open)]="isOpenOrganization"
                  [jdsBiDropdownLimitWidth]="'custom'"
                  [jdsBiDropdownMinWidth]="400"
                  [jdsBiDropdownMaxHeight]="300"
                  [jdsBiDropdownAlign]="'right'"
                  [content]="dropdownOrganization"
                >
                  <i
                    class="tblhd-icon"
                    [ngClass]="['active']"
                  ></i>
                </jds-bi-hosted-dropdown>
              </div>
            </th>
          </tr>
        </thead>
        <tbody>
          <ng-container
            *ngIf="vm.listEWalidataMonitorBusinessFieldMonitor as list"
          >
            <ng-container *ngIf="list.status === 'loading'">
              <ng-container *ngTemplateOutlet="loading" />
            </ng-container>

            <ng-container *ngIf="list.status === 'success'">
              <ng-container *ngIf="list.isFetching">
                <ng-container *ngTemplateOutlet="loading" />
              </ng-container>

              <ng-container *ngIf="!list.isFetching">
                <ng-container *ngIf="list.data.list.length > 0">
                  <tr *ngFor="let row of list.data.list; let i = index">
                    <td
                      [ngClass]="[jds.minW(60)]"
                      stickyColumn
                    >
                      {{
                        vm.filterPerPage * (vm.filterCurrentPage - 1) + (i + 1)
                      }}
                    </td>
                    <td
                      [ngClass]="[jds.minW(130)]"
                      stickyColumn
                    >
                      {{ row.kode_bidang_urusan }}
                    </td>
                    <td
                      [ngClass]="[jds.minW(400)]"
                      stickyColumn
                    >
                      {{ row.nama_bidang_urusan }}
                    </td>
                    <td>
                      <div
                        [ngClass]="[
                          jds.d('flex'),
                          jds.alignItems('center'),
                          jds.gap(8),
                          jds.w('full')
                        ]"
                      >
                        <div
                          [ngClass]="[jds.progress, jds.h(7.5)]"
                          [style.width.%]="65"
                        >
                          <div
                            [ngClass]="[
                              jds.progressBar,
                              jds.bg(jdsBiColor.green['600'])
                            ]"
                            [style.width.%]="row.count_diisi_persentase"
                            role="progressbar"
                          ></div>
                        </div>
                        <div [ngClass]="[jds.fw('bold')]">
                          {{
                            row.count_diisi_persentase | number : '1.0-1' : 'id'
                          }}
                          %
                        </div>
                      </div>
                    </td>
                    <td>
                      {{ row.count_belum_ditugaskan | number : '1.0-0' : 'id' }}
                    </td>
                    <td>
                      {{ row.count_ditugaskan | number : '1.0-0' : 'id' }}
                    </td>
                    <td>
                      {{ row.count_dikembalikan | number : '1.0-0' : 'id' }}
                    </td>
                    <td>
                      {{
                        row.count_pengajuan_nonaktif | number : '1.0-0' : 'id'
                      }}
                    </td>
                    <td>{{ row.count_nonaktif | number : '1.0-0' : 'id' }}</td>
                    <td>{{ row.getLastUpdate() }}</td>
                    <td [ngClass]="[jds.fw('bold')]">
                      {{ row.getOrganization() }}
                    </td>
                  </tr>
                </ng-container>

                <ng-container *ngIf="list.data.list.length === 0">
                  <ng-container *ngTemplateOutlet="empty" />
                </ng-container>
              </ng-container>
            </ng-container>
          </ng-container>
        </tbody>
      </table>
    </div>

    <ng-container *ngIf="vm.listEWalidataMonitorBusinessFieldMonitor as list">
      <ng-container *ngIf="list.status === 'success'">
        <ng-container *ngIf="list.data.list.length > 0">
          <jds-bi-pagination
            [colorScheme]="colorScheme"
            [perPageItems]="perPageItems"
            [pagination]="list.data.pagination"
            [perPage]="vm.filterPerPage"
            [page]="vm.filterCurrentPage"
            (filterPerPage)="onPerPage($event)"
            (filterPage)="onPage($event)"
          />
        </ng-container>
      </ng-container>
    </ng-container>
  </div>

  <ng-template #dropdownOrganization>
    <div [ngClass]="[jds.px(16), jds.pt(12), jds.pb(8)]">
      <ng-container
        *ngIf="vm.listOrganizationSatuData as listOrganizationSatuData"
      >
        <ng-container *ngIf="listOrganizationSatuData.status === 'loading'">
          <ng-container *ngTemplateOutlet="loadingOrganization" />
        </ng-container>

        <ng-container *ngIf="listOrganizationSatuData.status === 'success'">
          <ng-container *ngIf="listOrganizationSatuData.isFetching">
            <ng-container *ngTemplateOutlet="loadingOrganization" />
          </ng-container>

          <ng-container *ngIf="!listOrganizationSatuData.isFetching">
            <ul
              [ngClass]="[jds.ps(0), jds.mb(0)]"
              [style.listStyle]="'none'"
              [style.height]="'auto'"
            >
              <li
                *ngFor="let item of listOrganizationSatuData.data.list"
                [ngClass]="[jds.mb(5), jds.pe(15)]"
              >
                <div [ngClass]="[jds.formCheck]">
                  <input
                    id="checkbox-organization-{{ item.id }}"
                    [(ngModel)]="item.checked"
                    [ngClass]="[jds.formCheckInput]"
                    (change)="
                      onFilterOrganization(
                        item.kode_skpd,
                        $event.target.checked
                      )
                    "
                    type="checkbox"
                  />
                  <label
                    [ngClass]="[jds.formCheckLabel]"
                    for="checkbox-organization-{{ item.id }}"
                  >
                    {{ item.nama_skpd }}
                  </label>
                </div>
              </li>
            </ul>
          </ng-container>
        </ng-container>
      </ng-container>
    </div>
  </ng-template>
</ng-container>

<ng-template #empty>
  <tr>
    <td
      [style.width.%]="100"
      [attr.colspan]="11"
      [ngClass]="[jds.textAlign('center')]"
    >
      Tidak ada Data.
    </td>
  </tr>
</ng-template>

<ng-template #loading>
  <tr *ngFor="let i of [0, 1, 2, 3, 4, 5, 6, 7, 8, 9]">
    <td
      *ngFor="let j of [60, 130, 400]"
      [style.minWidth.%]="j"
      stickyColumn
    >
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: '80%',
            'border-radius': '0',
            height: '22px',
            'margin-bottom': '0px'
          }"
        />
      </div>
    </td>
    <td
      *ngFor="let j of [200, 130, 130, 130, 130, 130, 130, 165, 350]"
      [style.minWidth.%]="j"
    >
      <div class="wrapper-skeleton">
        <ngx-skeleton-loader
          [theme]="{
            width: '80%',
            'border-radius': '0',
            height: '22px',
            'margin-bottom': '0px'
          }"
        />
      </div>
    </td>
  </tr>
</ng-template>

<ng-template #loadingOrganization>
  <ng-container *ngFor="let i of [50, 75, 25]">
    <ngx-skeleton-loader
      [theme]="{
        width: i + '%',
        'border-radius': '0',
        height: '20px',
        'margin-bottom': '5px'
      }"
    />
  </ng-container>
</ng-template>
